#ifndef _rs232_h
#define _rs232_h

#define SZ_TX ( 16 )
#define SZ_RX ( 16 )
#define SZ_STX ( 128 )

#ifndef ASSEMBLER

#ifndef TRUE //{
typedef int bool;
#define TRUE  ((bool)1)
#define FALSE ((bool)0)
#endif //}

extern void* rs232_S;
typedef struct {
				volatile char*	pTx; // pointer transmit
				volatile char*	pRx; // pointer receive
				
				volatile char tx_buffer[SZ_TX];
				char pTxe[0]; // place holder for an end address.
				volatile char rx_buffer[SZ_RX];
				char pRxe[0]; // place holder for an end address.

				char *sIn, *sOut;
				char s_buffer[SZ_STX]; // slow put buffer
				char sEnd[0]; // place holder for end address.
				long	cog;
		} rs232_t ;


union rs232_ctt ;// define class type tag name for method parameters
typedef struct {
	// destructor
	void  (*destroy)( union rs232_ctt* );

	// constructor
    void (*init)( union rs232_ctt*, 
			int txpin, int rxpin, int mode, int baudrate );

	// Generic methods
	void (*iFlush)( union rs232_ctt* );
	int  (*nbGetchar)( union rs232_ctt* );
	int  (*getchar)( union rs232_ctt* );
	int  (*nbPutchar)( union rs232_ctt*, unsigned char ch );
	int  (*putchar)( union rs232_ctt*, unsigned char ch );
	int  (*nbPuts)( union rs232_ctt*, unsigned char* str );
	int  (*puts)( union rs232_ctt*, unsigned char* str );
	void (*sputchar)( union rs232_ctt*, unsigned char ch );
	void (*sputs)( union rs232_ctt*, unsigned char* str );
	
} rs232_mt;

// Create a class of type rs232_ct, that binds rs232_t and rs232_mt together.
#define _VOID_NEW_CLASS rs232
#include "voidbind.h"

#endif // ifndef ASSEMBLER
#endif

