// A test harness for the rs232 object, written in C.

#include "gcc2catalina.h"
#include "rs232.h"

#define _VOID_FINALIZE // No more objects will be defined after this point
#include "voidbind.h" // finalize the C object array list (make const/permanent)

rs232_ct com1;  // Create an object instance of the RS232 transmitter

int main(void) {
// All static variables, being in BSS, are presumed zeroed by C startup.
// All chip initialization is done here, in main.

	int tmp, dir, out;
	char sbuff[64];

	dira( 0x3FFFFFFF, 0 ); // reset all low dir bits.
	// Hold SYNC low until axii are all initialized.
	outa( (BIT(0)), 0  ); // Initial sync is OFF.
	outa( (BIT(16)), 1 ); // Turn on an indicator light to prove running
	dira( (BIT(0)|BIT(16)), 1 ); // Outputs enabled

	// Pin 26 is 7th left hole, Pin 27 is 7th right hole.
	M( com1, init, 27, 26, 0, 9600 ); // Tx=pin27, Rx=pin26, mode, baud
	M( com1, puts, "\nStart\n" ); // do method com1.puts( "\nStart\n")
	
	// Normal program code would go here.	
	
	M( com1, puts, "Stop\n");

	while( TRUE ) {
		int ch=M(com1,nbGetchar);
		if (ch>=0) M(com1,sputchar,ch);
	}

	M( com1, destroy );
}
